图的遍历方式: (1)深度优先遍历:遍历到不能前进时才回到上一个岔路口; (2)广度优先遍历:扩散式遍历;
1. leetcode 733-图像渲染
1.1 题目描述
有一幅以二维整数数组表示的图画,每一个整数表示该图画的像素值大小,数值在 0 到 65535 之间。
给你一个坐标 (sr, sc) 表示图像渲染开始的像素值(行 ,列)和一个新的颜色值 newColor,让你重新上色这幅图像。
为了完成上色工作,从初始坐标开始,记录初始坐标的上下左右四个方向上像素值与初始坐标相同的相连像素点,接着再记录这四个方向上符合条件的像素点与他们对应四个方向上像素值与初始坐标相同的相连像素点,……,重复该过程。将所有有记录的像素点的颜色值改为新的颜色值。
最后返回经过上色渲染后的图像。
示例 1:
输入: image = [[1,1,1],[1,1,0],[1,0,1]] sr = 1, sc = 1, newColor = 2 输出: [[2,2,2],[2,2,0],[2,0,1]] 解析: 在图像的正中间,(坐标(sr,sc)=(1,1)), 在路径上所有符合条件的像素点的颜色都被更改成2。 注意,右下角的像素没有更改为2, 因为它不是在上下左右四个方向上与初始点相连的像素点。
注意:
image 和 image[0] 的长度在范围 [1, 50] 内。 给出的初始点将满足 0 <= sr < image.length 和 0 <= sc < image[0].length。 image[i][j] 和 newColor 表示的颜色值在范围 [0, 65535]内。
来源:力扣(LeetCode) 链接:https://leetcode-cn.com/problems/flood-fill 著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
1.2 代码实现
思路:深度优先,对于当前元素,首先更新它的颜色,然后判断上下左右的4个元素是否符合更新条件,符合则更新。 我的提交:
class Solution {
public int[][] floodFill(int[][] image, int sr, int sc, int newColor) {
int color = image[sr][sc];
if(color == newColor){
return image;
}
dfs(image, sr, sc, newColor, color);
return image;
}
public void dfs(int[][] image, int sr, int sc, int newColor, int color){
image[sr][sc] = newColor;
if(sr-1 >= 0 && image[sr-1][sc] == color){
dfs(image, sr-1, sc, newColor, color);
}
if(sr+1 < image.length && image[sr+1][sc] == color){
dfs(image, sr+1, sc, newColor, color);
}
if(sc-1 >= 0 && image[sr][sc-1] == color){
dfs(image, sr, sc-1, newColor, color);
}
if(sc+1 < image[0].length && image[sr][sc+1] == color){
dfs(image, sr, sc+1, newColor, color);
}
}
}
时间复杂度:O(nm),image数组的大小,最坏情况所有元素颜色都要更新; 空间复杂度:O(nm),栈空间的开销。
2. leetcode 695-岛屿的最大面积
2.1 题目描述
给定一个包含了一些 0 和 1 的非空二维数组 grid 。
一个 岛屿 是由一些相邻的 1 (代表土地) 构成的组合,这里的「相邻」要求两个 1 必须在水平或者竖直方向上相邻。你可以假设 grid 的四个边缘都被 0(代表水)包围着。
找到给定的二维数组中最大的岛屿面积。(如果没有岛屿,则返回面积为 0 。)
示例 1:
[[0,0,1,0,0,0,0,1,0,0,0,0,0], [0,0,0,0,0,0,0,1,1,1,0,0,0], [0,1,1,0,1,0,0,0,0,0,0,0,0], [0,1,0,0,1,1,0,0,1,0,1,0,0], [0,1,0,0,1,1,0,0,1,1,1,0,0], [0,0,0,0,0,0,0,0,0,0,1,0,0], [0,0,0,0,0,0,0,1,1,1,0,0,0], [0,0,0,0,0,0,0,1,1,0,0,0,0]] 对于上面这个给定矩阵应返回 6。注意答案不应该是 11 ,因为岛屿只能包含水平或垂直的四个方向的 1 。
示例 2:
[[0,0,0,0,0,0,0,0]] 对于上面这个给定的矩阵, 返回 0。
注意: 给定的矩阵grid 的长度和宽度都不超过 50。
来源:力扣(LeetCode) 链接:https://leetcode-cn.com/problems/max-area-of-island 著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
2.2 代码实现
我的提交
我的思路:依次判断数组grid中为1的元素,统计这个1所在的岛屿面积,与最大值比较并更新最大值。其中,判断当前为1的元素所在岛屿的面积用的深度优先搜索方法。 可以改进的地方:代码可以写的更简洁一些。
class Solution {
int[] row = {-1,1,0,0};
int[] column = {0,0,-1,1};
int count = 1;
public int maxAreaOfIsland(int[][] grid) {
int maxArea = 0;
for(int i = 0; i < grid.length; i++){
for(int j = 0; j < grid[0].length; j++){
if(grid[i][j] == 1){
count = 1;
dfs(grid, i , j);
maxArea = Math.max(maxArea, count);
}
}
}
return maxArea;
}
public void dfs(int[][] grid, int i, int j){
grid[i][j] = 999;
for(int t = 0; t < 4; t++){
int mi = i + row[t];
int mj = j + column[t];
if(mi >= 0 && mi < grid.length && mj >= 0 && mj < grid[0].length && grid[mi][mj] == 1 && grid[mi][mj] != 999){
count++;
dfs(grid, mi, mj);
}else{
continue;
}
}
}
}
时间复杂度:O(RC), RC为数组grid的大小; 空间复杂度:栈空间为O(R*C).
参考官答
深度优先遍历: 参考1:
class Solution {
public int maxAreaOfIsland(int[][] grid) {
int ans = 0;
for(int i = 0; i < grid.length; i++){
for(int j = 0; j < grid[0].length; j++){
ans = Math.max(ans, dfs(grid, i, j));
}
}
return ans;
}
public int dfs(int[][] grid, int i, int j){
if(i < 0 || i >= grid.length || j < 0 || j >= grid[0].length || grid[i][j] == 0){
return 0;
}
grid[i][j] = 0;
int num = 1;
num += dfs(grid, i-1, j);
num += dfs(grid, i+1, j);
num += dfs(grid, i, j-1);
num += dfs(grid, i, j+1);
return num;
}
}
参考2:和参考1的dfs方法稍有不同
class Solution {
public int maxAreaOfIsland(int[][] grid) {
int ans = 0;
for(int i = 0; i < grid.length; i++){
for(int j = 0; j < grid[0].length; j++){
ans = Math.max(ans, dfs(grid, i, j));
}
}
return ans;
}
public int dfs(int[][] grid, int i, int j){
if(i >= 0 && i < grid.length && j >= 0 && j < grid[0].length){
if(grid[i][j] == 0){
return 0;
}else{
grid[i][j] = 0;
return 1 + dfs(grid, i-1, j)
+ dfs(grid, i+1, j)
+ dfs(grid, i, j-1)
+dfs(grid, i, j+1);
}
}
return 0;
}
}
|